/*
 * http_request.c: functions to get and process requests
 * 
 * Rob McCool 3/21/93
 * 
 * Include code by Charles Henrich
 */


#include "httpd.h"

int assbackwards;
char *remote_host;
char *remote_ip;
char *remote_name;

void process_request(FILE *in, FILE *out) {
    char m[HUGE_STRING_LEN];
    char w[HUGE_STRING_LEN];
    char l[HUGE_STRING_LEN];
    char url[HUGE_STRING_LEN];
    char args[HUGE_STRING_LEN];
    int s;

    get_remote_host(fileno(in));
    if(getline(l,HUGE_STRING_LEN,in,timeout))
        exit(1);

    log_transaction(l);
    getword(m,l,' ');
    getword(args,l,' ');
    getword(url,args,'?');
    unescape_url(url);
    getword(w,l,'\0');
    if(w[0] != '\0') {
        assbackwards = 0;
        get_mime_headers(in);
    }
    else
        assbackwards = 1;

    if(!strcmp(m,"HEAD")) {
        header_only=1;
        goto processme;
    }
    if(!strcmp(m,"GET")) {
        header_only=0;
      processme:
        if(assbackwards && header_only) {
            header_only = 0;
            die(BAD_REQUEST,"Invalid HTTP/0.9 method.",out);
        }
        if(translate_name(url,out))
            exec_get_script(url,args,out);
        else
            send_node(url,args,out);
    }
    else if(!strcmp(m,"POST")) {
        s = translate_name(url,out);
        get_node(url,args,in,out,s);
    }
    else 
        die(BAD_REQUEST,"Invalid or unsupported method.",out);
}
